
/* chat with network port 
   script files start with hostname and port on first line
   and each subsequent lines start with WAIT: or SEND:

   Netchat understands these commands:
   WAIT:<string>   waits for <string> (2 seconds timeout)
   SEND:<string>   sends <string>
   INTERACTIVE: control is given to terminal

   example input file:
   -------------------
   10.1.1.1 23
   WAIT:sername:
   SEND:joe\n
   WAIT:ssword:
   SEND:doe\n
   SEND:exit\n
   -------------------
*/

/* Ioannou Spiros sivann at gmail.com*/
/* CHANGES
   1999 v0.1  first version, static chat
   8/8/2009 v.02 scripting capability
*/

#define WRDELAY 5000 /*delay between byte writes, for slow devices. In microseconds */

#include <syslog.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <poll.h>
#include <string.h>
#include <stropts.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <signal.h>
#include <stdio.h>
#include <errno.h>
#include <grp.h>
#include <limits.h>
#include <termio.h>



 char buffer[2048];
 const char * nl="\n";
 int lsd,lsd_b, a, b,r,w, i,Asd,Csd,Tsd,len;
 fd_set inout_fds;
 int  enable();

 struct sockaddr_in sa, in_sa,sc,in_sc;
 unsigned char in[2];
 struct hostent *chost;
 int ltc[8]; /*lines to clear*/
 int line[8]; /*line in use (=0) lines not in use (=-1) lines in ltc (=1)*/
 FILE *fp;
 static struct termios org_termios;



char *replace_str(char *str, char *orig, char *rep) 
{
  static char buffer[4096];
  char *p;

  if(!(p = strstr(str, orig)))  // Is 'orig' even in 'str'?
    return str;

  strncpy(buffer, str, p-str); // Copy characters from 'str' start to 'orig' st$
  buffer[p-str] = '\0';

  sprintf(buffer+(p-str), "%s%s", rep, p+strlen(orig));

  return buffer;
}


no_wait()
{
    int fd , i;
    struct termio termio_s;

    fd=open(ttyname(0),O_WRONLY);
    ioctl(fd, TCGETA, &termio_s);
    termio_s.c_cc[VMIN]=1;
    termio_s.c_lflag = ISIG;

    ioctl(fd, TCSETA, &termio_s);
    close(fd);
}


/*
usleep(useconds_t x) {
        struct timeval  time;

        time.tv_sec= x/1000000;
        time.tv_usec=x%1000000;
        select(0, NULL, NULL, NULL, &time);
}
*/


slowrite(int sd,char * buf,int bs,int show)
{
int i;

    for (i=0;i<bs;i++){
	usleep(WRDELAY);
	write(sd,buf+i,sizeof(*buf));
	if (show)
	  write(1,buf+i,sizeof(*buf));
	/*
	else
	  write(1,"*",sizeof("*"));
	*/
    }
}


void alarm_handler(int arg)
{
  fprintf(stderr,"\nnetchat: timeout waiting for \"%s\", exiting\n",buffer+5);
  exit(2);
}

void tty_reset() {
    /* resets tty to the original state, saved in org_termios */
    tcsetattr(0, TCSAFLUSH, &org_termios);
}

main (int argc,char *argv[]) {
 

  int doit=0;
  char host[200];
  int port;

  /* store terminal settings */
  tcgetattr(0,&org_termios);
  atexit(tty_reset);

  Csd=-1;

  if (argc!=2) {
   fprintf(stderr,"Usage: %s <chatfile>\n",argv[0]);
   exit(1);
  }

  fp=fopen(argv[1],"r");
  if (!fp) {
    perror(argv[1]);
    exit (3);
  }



  /* Set an inactivity alarm, it may hang, nobody's perfect*/
  alarm(2); //2 seconds
  signal(SIGALRM,alarm_handler);

  //read host name
  fgets(buffer,200,fp);
  sscanf(buffer,"%s %d",host,&port);

  if (connectC(host,port)<0) { /*telnet*/
    exit(3);
  }

  
  chat();
  shutdown(Csd,2);
  close(Csd);

}

connectC(const char * host,int port)
{
/*Open C socket and connect to C host*/

	if ((Csd = socket (AF_INET, SOCK_STREAM, 0)) < 0) {
	  return (-1);
	}
	sc.sin_port = htons ((u_short) port);

	 chost = gethostbyname (host);
         if (!chost) return (-2);
	 /*
	 printf ("\nC address : %s %d \n" , inet_ntoa (chost->h_addr),
		 ntohs(sc.sin_port)); 
	 */

	 sc.sin_family = AF_INET;
	 memcpy (&sc.sin_addr, chost->h_addr, chost->h_length);

	if (connect (Csd,(struct sockaddr *) &sc, sizeof (sc)) < 0) {
	  fprintf(stderr,"cannot connect to %s %d:%s\n",host,port,strerror(errno));
	  return (-3);
	}
       return (1); 
}

waitfor(char *str,int Csd)
{
  char buffer[2000];
  int c=0;
  char *s;

  do {
       c++;
       r=read(Csd,buffer,2000);
       buffer[r]=0;
       printf("%s",buffer);
       fflush(stdout);
       usleep(1000);
   } while (c<10 && !(s=strstr(buffer,str))) ;

   if (!s) {
     printf("netchat:%s: not found!\n",str);
     fflush(stdout);
     return(-1);
   }
   else 
     return (1);
}

void gointeractive()
{
 
 alarm(0);
 no_wait();
 fflush(stdout);
 buffer[0]=0;

 for(;;) {
   FD_ZERO(&inout_fds);
   FD_SET(0, &inout_fds); 
   FD_SET(Csd, &inout_fds); 
   i = select(16,&inout_fds,(fd_set *)0,(fd_set *)0,0);
   if (FD_ISSET(0,&inout_fds)) {
     r=read(0,buffer,1024);
     w=write(Csd,buffer,r);
     if (w<0) exit(w);
   }
   else if (FD_ISSET(Csd,&inout_fds)) {
     r=read(Csd,buffer,1024);
     write(1,buffer,r);
     if (r<=0) exit(r);
   }

 }

}

chat()
{
  int c=0;
  char *s;


  while (!feof(fp)) {
    buffer[0]=0;
    fgets(buffer,1024,fp);
    if (strlen(buffer)<2) continue;

    s=replace_str(buffer, "\\n", "\n");
    strcpy(buffer,s);
    s=replace_str(buffer, "\\r", "\r");
    strcpy(buffer,s);

    if (buffer[strlen(buffer)-1]=='\n')
      buffer[strlen(buffer)-1]=0; //chop

    if (strncasecmp("WAIT:",buffer,5)==0) {
      alarm(2);
      waitfor(buffer+5,Csd);
    }
    else if (strncasecmp("SEND:",buffer,5)==0) {
      slowrite(Csd,buffer+5,strlen(buffer+5),0);
    }
    else if (buffer[0]=='#') continue; //comments
    else if (strncasecmp("INTERACTIVE:",buffer,12)==0) {
      gointeractive();
    }
    else {
      fprintf(stderr,"syntax error: %s, lines may start with WAIT: , SEND: or #\n",buffer);
    }
  }
}

